const Main = imports.ui.main;
const Meta = imports.gi.Meta;
const Shell = imports.gi.Shell;

/* Switch to the last used other desktop */
function _doSwitchDesktop(display, screen, window, binding) {
    let activeWorkspace = screen.get_active_workspace();
    let appSys = Shell.AppSystem.get_default();
    let apps = appSys.get_running();
    let lastWindow = null;
    let lastWindowTime = 0;
    for (let i = 0; i < apps.length; i++) {
        let windows = apps[i].get_windows();
        for(let j = 0; j < windows.length; j++) {
            let win = windows[j];
            if (win.get_workspace() != activeWorkspace) {
                if (win.get_user_time() > lastWindowTime) {
                    lastWindow = win;
                    lastWindowTime = lastWindow.get_user_time();
                }
            }
        }
    }
    if (lastWindow) {
        Main.activateWindow(lastWindow);
    }
}

function init() {
}

function enable() {
    Meta.keybindings_set_custom_handler('switch-group', _doSwitchDesktop);
    Meta.keybindings_set_custom_handler('switch-group-backward', _doSwitchDesktop);
}

function disable() {
    Meta.keybindings_set_custom_handler('switch-group', Lang.bind(Main.wm, Main.wm._startAppSwitcher));
    Meta.keybindings_set_custom_handler('switch-group-backward', Lang.bind(Main.wm, Main.wm._startAppSwitcher));
}
